VERSION 5.00
Begin VB.Form FrmMemoryCard 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "x"
   ClientHeight    =   3015
   ClientLeft      =   45
   ClientTop       =   645
   ClientWidth     =   5895
   ClipControls    =   0   'False
   ControlBox      =   0   'False
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3015
   ScaleWidth      =   5895
   StartUpPosition =   1  'CenterOwner
   Begin VB.FileListBox LstFile 
      Height          =   1260
      Left            =   240
      TabIndex        =   9
      Top             =   4920
      Width           =   4455
   End
   Begin VB.DirListBox LstDir 
      Height          =   1665
      Left            =   120
      TabIndex        =   8
      Top             =   3600
      Width           =   4575
   End
   Begin VB.Frame Frame1 
      Height          =   975
      Left            =   120
      TabIndex        =   4
      Top             =   1920
      Width           =   5655
      Begin VB.CommandButton BtnOK 
         Caption         =   "OK"
         Enabled         =   0   'False
         Height          =   375
         Left            =   3000
         TabIndex        =   7
         Top             =   360
         Width           =   1095
      End
      Begin VB.CommandButton BtnCancel 
         Caption         =   "Cancel"
         Height          =   375
         Left            =   4320
         TabIndex        =   6
         Top             =   360
         Width           =   1095
      End
      Begin VB.CommandButton BtnCheck 
         Caption         =   "Integrity Check"
         Enabled         =   0   'False
         Height          =   375
         Left            =   240
         TabIndex        =   5
         Top             =   360
         Width           =   2415
      End
   End
   Begin VB.Frame Frame3 
      ClipControls    =   0   'False
      Height          =   855
      Left            =   120
      TabIndex        =   2
      Top             =   960
      Width           =   5655
      Begin VB.Label LblInfo 
         Alignment       =   2  'Center
         AutoSize        =   -1  'True
         Caption         =   "No memorycard selected ..."
         ForeColor       =   &H000000FF&
         Height          =   195
         Left            =   120
         TabIndex        =   3
         Top             =   360
         Width           =   5445
      End
   End
   Begin VB.Frame FrmDrive 
      Caption         =   "Drive"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   855
      Left            =   120
      TabIndex        =   0
      Top             =   0
      Width           =   5655
      Begin VB.ComboBox CmbDrives 
         Appearance      =   0  'Flat
         Height          =   315
         Left            =   120
         Style           =   2  'Dropdown List
         TabIndex        =   1
         Top             =   360
         Width           =   5295
      End
   End
   Begin VB.Menu TopFile 
      Caption         =   "File"
      Begin VB.Menu MnuIntegrity 
         Caption         =   "Integrity Check"
         Shortcut        =   ^I
      End
      Begin VB.Menu line0 
         Caption         =   "-"
      End
      Begin VB.Menu MnuOK 
         Caption         =   "OK"
         Shortcut        =   ^S
      End
      Begin VB.Menu MnuCancel 
         Caption         =   "Cancel"
         Shortcut        =   ^Q
      End
   End
End
Attribute VB_Name = "FrmMemoryCard"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Private Sub BtnCancel_Click()
    Unload Me
End Sub

Private Sub BtnCheck_Click()
    If CheckIntegrity = True Then
        LblInfo.Caption = " integrity check OK for " & Left$(CmbDrives.Text, 3)
    Else
        LblInfo.Caption = " integrity check failed for " & Left$(CmbDrives.Text, 3)
    End If
End Sub

Private Sub BtnOK_Click()
    FrmMain.TxtMemorycard.Text = CmbDrives.Text
    FrmMain.MnuPlayLists.Enabled = True
    FrmMain.MnuScheduler.Enabled = True
    Unload Me
End Sub

Private Sub CmbDrives_Click()
    If CmbDrives.ListIndex > -1 Then
        BtnOK.Enabled = True
        LblInfo.Caption = Left$(CmbDrives.Text, 3) & " selected ..."
        BtnCheck.Enabled = True
    Else
        BtnOK.Enabled = False
        BtnCheck.Enabled = False
        LblInfo.Caption = "No memorycard selected ..."
    End If
End Sub

Private Sub Form_Load()
    '--- declares ---
    Dim StrAllDrives As String
    Dim StrDrive As String
    
    Me.Caption = gAppName & " v" & gVersion & " - memorycard"

    '--- get the list of all drives ---
    StrAllDrives = GetDriveString()
 
    '--- separate the drive strings and add removable media to dropdown ---
    Do Until StrAllDrives = Chr$(0)
        StrDrive = StripNulls(StrAllDrives)
        If GetDriveType(Left(StrDrive, 1)) = 2 Then '--- so, we have a "removable" device ...
            If Int(((GetSectorsForDrive(Left(StrDrive, 1)) * 512) / 1024) / 1024) > 0 Then  '--- there is media in the device ---
                CmbDrives.AddItem StrDrive & "   " & Int(((GetSectorsForDrive(Left(StrDrive, 1)) * 512) / 1024) / 1024) & " MB" & "   (" & GetSectorsForDrive(Left(StrDrive, 1)) & " sectors)"
            End If
        End If
   Loop

End Sub

Private Function CheckIntegrity() As Boolean
    Dim StrText As String
    Dim BoolOK As Boolean
    Dim IntI As Integer
    Dim IntFreeFile As Integer
    Dim StrDisplayFormat As String
    Dim StrData As String
    Dim BoolDisplayOK As Boolean
    Dim StrAniFiles(9999) As String
    Dim StrLstFiles(9999) As String
    Dim IntAniFiles As Integer
    Dim IntCount As Integer
    Dim IntLstFiles As Integer
    Dim BoolTestFile As Boolean
    Dim BoolTestFileSet As Boolean
    
    LstDir.Path = Left$(CmbDrives.Text, 3)
    LstFile.Path = Left$(CmbDrives.Text, 3)
    BoolOK = True
    BoolDisplayOK = True
    StrDisplayFormat = ""
    IntAniFiles = 0
    IntLstFiles = 0
    
    '--- check if subdirs on memorycard ---
    If LstDir.ListCount > 0 Then
        StrText = StrText & "Subdirectories not allowed on " & gAppName & " memorycard." & vbCrLf
        BoolOK = False
    End If

    '--- first, check for ANI files (also look if they are valid) ---
    LstFile.Pattern = "*.ANI"
    If LstFile.ListCount > 0 Then
        StrText = StrText & "Number of animation files found on memorycard: " & CStr(LstFile.ListCount) & vbCrLf
        For IntI = 0 To LstFile.ListCount - 1
            IntFreeFile = FreeFile
            Open Left$(CmbDrives.Text, 3) & LstFile.List(IntI) For Binary As #IntFreeFile
            StrData = Space$(13)
            Get #IntFreeFile, , StrData
            If StrData <> "[GLYPHIX ANI]" Then
                BoolOK = False
                StrText = StrText & "Invalid animation file: " & LstFile.List(IntI) & vbCrLf
            Else
                IntAniFiles = IntAniFiles + 1
                StrAniFiles(IntAniFiles) = LstFile.List(IntI)
                StrData = Space$(32)
                Get #IntFreeFile, , StrData
                StrData = Space$(13)
                Get #IntFreeFile, , StrData
                If Len(StrDisplayFormat) < 1 Then
                    StrDisplayFormat = StrData
                Else
                    If StrData <> StrDisplayFormat Then
                        BoolDisplayOK = False
                    End If
                End If
            End If
            Close #IntFreeFile
        Next IntI
        
    Else
        StrText = StrText & "No valid animation files found on memorycard." & vbCrLf
        BoolOK = False
    End If
    
    '--- next, check for LST files (also check if any ANI file declared in it, is on the memorycard) ---
    LstFile.Pattern = "*.LST"
    If LstFile.ListCount > 0 Then
        StrText = StrText & "Number of playlist files found on memorycard: " & CStr(LstFile.ListCount) & vbCrLf
        For IntI = 0 To LstFile.ListCount - 1
            IntFreeFile = FreeFile
            Open Left$(CmbDrives.Text, 3) & LstFile.List(IntI) For Binary As #IntFreeFile
            StrData = Space$(13)
            Get #IntFreeFile, , StrData
            If StrData <> "[GLYPHIX LST]" Then
                BoolOK = False
                StrText = StrText & "Invalid playlist file: " & LstFile.List(IntI) & vbCrLf
            Else
                '--- first, get displaysize ---
                StrData = Space$(32)
                Get #IntFreeFile, , StrData
                StrData = Space$(13)
                Get #IntFreeFile, , StrData
                If Len(StrDisplayFormat) < 1 Then
                    StrDisplayFormat = StrData
                Else
                    If StrData <> StrDisplayFormat Then
                        BoolDisplayOK = False
                    End If
                End If
                
                '--- then, we need to check that all ANI files are valid, before adding this file to the LSTfiles-array ---
                '--- so we need to loop trough the ANI files, declared in the LST file                                   ---
                                
                'IntLstFiles = IntLstFiles + 1
                'StrLstFiles(IntLstFiles) = LstFile.List(IntI)
                BoolTestFileSet = True
                While Not EOF(IntFreeFile)
                    StrData = Space$(12)
                    Get #IntFreeFile, , StrData
                    StrData = Replace(StrData, " ", "")
                    If Asc(Left$(StrData, 1)) <> 0 Then
                        BoolTestFile = False
                        For IntCount = 1 To IntAniFiles
                            If UCase(StrData) = UCase(StrAniFiles(IntCount)) Then
                                BoolTestFile = True
                                Exit For
                            End If
                        Next IntCount
                        If BoolTestFile = False Then
                            StrText = StrText & "Animation '" & StrData & "' in playlist '" & Left$(CmbDrives.Text, 3) & LstFile.List(IntI) & "' Not found or invalid !" & vbCrLf
                            BoolTestFileSet = False
                            BoolOK = False
                        End If
                    End If
                Wend
                If BoolTestFileSet = True Then
                    IntLstFiles = IntLstFiles + 1
                    StrLstFiles(IntLstFiles) = LstFile.List(IntI)
                End If
            End If
            Close #IntFreeFile
        Next IntI
        
    Else
        StrText = StrText & "No valid playlist files found on memorycard." & vbCrLf
        BoolOK = False
    End If
    
    '--- next, check for SCH file (glyphix.sch), and look if ANI and LST files in it, are on the memory card ---
    If Len(Dir(Left$(CmbDrives.Text, 3) & "GLYPHIX.SCH")) > 0 Then
        '--- openup file, and see if everything is ok ---
        
    Else
        StrText = "Scheduler file 'glyphix.sch' is missing !" & vbCrLf
        BoolOK = False
    End If
    
    If BoolDisplayOK = False Then
        BoolOK = False
        StrText = StrText & "Mixing of display-sizes is not allowed !"
    Else
        StrText = StrText & "Display format: " & StrDisplayFormat
    End If
    
    If BoolOK = False Then
        MsgBox StrText, vbCritical, "Integrity check failed for " & Left$(CmbDrives.Text, 3)
    Else
        MsgBox StrText, vbInformation, "Integrity check OK for " & Left$(CmbDrives.Text, 3)
    End If
    
    CheckIntegrity = BoolOK
End Function

Private Sub MnuCancel_Click()
    BtnCancel_Click
End Sub

Private Sub MnuIntegrity_Click()
    BtnCheck_Click
End Sub

Private Sub MnuOK_Click()
    BtnOK_Click
End Sub
